﻿using System.Buffers;
using Dto;
using Model;

namespace ApiMappeur;
public static class UserMappeur
{
    private static readonly ArrayPool<UserDto> UserDtoPool = ArrayPool<UserDto>.Create();
    private static readonly Dictionary<User, UserDto> userToDtoMap = new Dictionary<User, UserDto>();
    private static readonly Dictionary<UserDto, User> dtoToUserMap = new Dictionary<UserDto, User>();
    public static UserDto ToDto(this User user)
    {
        return new UserDto
        {
            Id = user.Id,
            Username = user.Username,
            ProfilePicture = user.ProfilePicture,
            LastName = user.LastName,
            FirstName = user.FirstName,
            Email = user.Email,
            Password = user.MotDePasse,
            Sexe = user.Sexe,
            Lenght = user.Lenght,
            Weight = user.Weight,
            DateOfBirth = user.DateOfBirth,
            IsCoach = user.Role is Coach
        };
    }

    public static User ToModel(this UserDto userDto)
    {
        return new User
        {
            Username = userDto.Username,
            ProfilePicture = userDto.ProfilePicture,
            LastName = userDto.LastName,
            FirstName = userDto.FirstName,
            Email = userDto.Email,
            MotDePasse = userDto.Password,
            Sexe = userDto.Sexe,
            Lenght = userDto.Lenght,
            Weight = userDto.Weight,
            DateOfBirth = userDto.DateOfBirth,
            Role = userDto.IsCoach ? new Coach() : new Athlete()

        };
    }
}
/*
using Dto;
using Model;
using System.Buffers;

namespace ApiMappeur
{
    // anotine
    public static class UserMappeur
    {
        private static readonly ArrayPool<UserDto> UserDtoPool = ArrayPool<UserDto>.Create();

        public static UserDto ToDto(this User user)
        {
            UserDto userDto = UserDtoPool.Rent();
            userDto.Id = user.Id;
            userDto.Username = user.Username;
            userDto.ProfilePicture = user.ProfilePicture;
            userDto.LastName = user.LastName;
            userDto.FirstName = user.FirstName;
            userDto.Email = user.Email;
            userDto.Password = user.MotDePasse;
            userDto.Sexe = user.Sexe;
            userDto.Lenght = user.Lenght;
            userDto.Weight = user.Weight;
            userDto.DateOfBirth = user.DateOfBirth;
            userDto.IsCoach = user.Role is Coach;
            return userDto;
        }

        public static User ToModel(this UserDto userDto)
        {
            if (userDto.IsCoach)
            {
                return new User(
                    userDto.Username,
                    userDto.ProfilePicture,
                    userDto.LastName,
                    userDto.FirstName,
                    userDto.Email,
                    userDto.Password,
                    userDto.Sexe,
                    userDto.Lenght,
                    userDto.Weight,
                    userDto.DateOfBirth,
                    new Coach()
                );
            }
            return new User(
                userDto.Username,
                userDto.ProfilePicture,
                userDto.LastName,
                userDto.FirstName,
                userDto.Email,
                userDto.Password,
                userDto.Sexe,
                userDto.Lenght,
                userDto.Weight,
                userDto.DateOfBirth,
                new Athlete());
        }

        public static void ReturnToPool(this UserDto userDto)
        {
            UserDtoPool.Return(userDto);
        }
    }
}
*/